// fichier : student.cc
// version : 1.2
// 
#include <iostream>
#include <limits>
#include <vector>

using namespace std;
#include "student.h"

static    vector<Student> tab; // vide à l'initialisation

Student student_init(void)
{
	Student e;
	
	cout << "\nNom de famille : ";
	cin  >> e.nom ;
		
	cout << "\nPrénom : ";
	cin  >> e.prenom ;

	bool echec(false);
	do
	{
		echec = false;
		cout << "\nAge: ";
	    if(not(cin >> e.age))
        {
			echec = true;
			cin.clear();
			cin.ignore(numeric_limits<streamsize>::max(),'\n');
        }
	}while(echec || e.age <= 0);
	
    do
    {
	    cout << "\nsection (max "<< MAX_SECTION << " caractères): ";
	    cin  >> e.section;
	}while(e.section.size() != MAX_SECTION) ;

	return e;
}

// le test d'égalité de deux structures est possible grâce
// à la surcharge de l'opérateur == 
bool    student_add_to_database(const Student& new_student)
{	
	for(size_t i(0) ; i < tab.size() ; ++i)
		if(tab[i] == new_student) 
			return false;
	
	tab.push_back(new_student);
	return true;	
}

bool Student::operator==(const Student& b)
{
	return( student_are_the_same((*this), b));
}

bool Student::operator!=(const Student& b)
{
	return( not student_are_the_same((*this), b));
}


bool student_are_the_same(const Student& e1,const Student& e2)
{
	return(e1.nom    == e2.nom    && 
	       e1.prenom == e2.prenom &&
	       e1.age    == e2.age    &&
	       e1.section== e2.section);
}

// the special character '\t' is a tabulation
void	 student_display_all()
{
	for( const Student& e: tab)
	{
		cout << e.nom << " \t" << e.prenom << " \t" << e.age 
           << " \t"  << e.section << endl;
	}
}
